#ifdef __linux__

#include "stdafx.h"

#else

#include <string>
#include <exception>
#include <Isolator.h>
#include <gtest/gtest.h>
using namespace std;

#endif

#include "../ClassesUnderTest/Person.h"

/*
 * Isolator++ can enable you to call constructor on the fake object.
 * But only once per object lifetime
 */
class CallConstructorTests : public ::testing::Test
{
public:
	virtual void TearDown() 
	{
		ISOLATOR_CLEANUP();
	}
};

/*****************************************
	Calling constructor on the fake objects
******************************************/

/*
 * GetId() will return the original 1 value, although the object faked but constructor was called and id was set.
 */
TEST_F(CallConstructorTests, CallPublicConstructorWithArguments)
{
	auto fakePerson = FAKE<Person>();
	ISOLATOR_INVOKE_CONSTRUCTOR(fakePerson, 1);

	WHEN_CALLED(fakePerson->GetId()).CallOriginal(); 

	ASSERT_EQ(1, fakePerson->GetId());
}

TEST_F(CallConstructorTests, CallPrivateConstructorWithArguments)
{
	auto fakePerson = FAKE<Person>();
	char* lastName = "Smith";
	ISOLATOR_INVOKE_CONSTRUCTOR(fakePerson, lastName);

	ASSERT_EQ(lastName, fakePerson->lastName);
}
