#ifdef __linux__

#include "stdafx.h"

#else

#include <string>
#include <exception>
#include <Isolator.h>
#include <gtest/gtest.h>
using namespace std;

#endif

#include "../ClassesUnderTest/Person.h"

// when changing behavior to call original, the faked object will execute the original implementation of the method
class CallOriginalBehavior : public ::testing::Test
{
public:
	virtual void TearDown() 
	{
		ISOLATOR_CLEANUP();
	}
};

/*****************************************
	Calling original code on fake objects
******************************************/

/*
 * GetZipCode will return the original -1 value, although the object faked.
 */
TEST_F(CallOriginalBehavior, ExecuteOriginalOnAFakeObject)
{
	Person person;
	Address* fakeAddress = FAKE<Address>();

	WHEN_CALLED(fakeAddress->GetZipCode()).CallOriginal();

	ASSERT_EQ(-1, person.GetAddressZipCode(fakeAddress));
}
