#ifdef __linux__

#include "stdafx.h"

#else

#include <string>
#include <exception>
#include <Isolator.h>
#include <gtest/gtest.h>
using namespace std;

#endif

#include "../ClassesUnderTest/Person.h"

// recursive fakes return 0 or equivalent for methods returning values, and recursive fakes for calls returning classes
class CreateRecursiveFake : public ::testing::Test
{
public:
	virtual void TearDown() 
	{
		ISOLATOR_CLEANUP();		
	}
};

/*****************************************
		Recursive fakes
******************************************/

/*
 * Each fake instance is recursive fake by default, this means that
 * every method returning an instance will return a fake object.
 * In the example below Address->GetLocation(), being a fake, returns a faked instance of GPSLocation.
 * That fake instance has fake methods, and their default behavior, returning int,  is to return 0.
 */
TEST_F(CreateRecursiveFake, ReturnFakeObject)
{
	Person person;
	Address* fakeAddress = FAKE<Address>();

	GPSLocation* result = person.GetAddressLocation(fakeAddress);


	ASSERT_EQ(0, result->Latitude());
	ASSERT_EQ(0, result->Longitude());
}

