#ifdef __linux__

#include "stdafx.h"

#else

#include <string>
#include <exception>
#include <Isolator.h>
#include <gtest/gtest.h>
using namespace std;

#endif

#include "../ClassesUnderTest/Person.h"

class Ignore : public ::testing::Test
{
public:
	virtual void TearDown() 
	{
		ISOLATOR_CLEANUP();
	}
};

/*****************************************
		Faking void calls
******************************************/

/*
 * Ignore can be used to ignore void methods on live object.
 */
TEST_F(Ignore, IgnoreThrowingMethodOnLiveObject)
{
	Person person;
	Address address;

	WHEN_CALLED(address.SetCountry(ANY_VAL(string))).Ignore();

	// this would otherwise throw an exception
	person.SetAddressCountry(&address, ""); 
}
