#ifdef __linux__

#include "stdafx.h"

#else

#include <string>
#include <exception>
#include <Isolator.h>
#include <gtest/gtest.h>
using namespace std;

#endif

#include "../ClassesUnderTest/Person.h"
#include "../ClassesUnderTest/GPSLocation.h"
#include "../ClassesUnderTest/ITransport.h"
#include "../ClassesUnderTest/Address.h"

class ReturnByValueTests : public ::testing::Test
{
public:
	virtual void TearDown()
	{
		ISOLATOR_CLEANUP();
	}

};

/*****************************************
		Return object by value
******************************************/

/*	In this test we show, how to fake method to return an object with specified values. 
	I.e. return it by value using BY_VAL macro in Return.
*/
TEST_F(ReturnByValueTests, ReturnLocations)
{
	GPSLocation testLocation = GPSLocation (1, 1);
	Person realPerson = Person();

	vector<GPSLocation> testStopsVector;
	testStopsVector.push_back(GPSLocation(0, 0));
	testStopsVector.push_back(testLocation);
	testStopsVector.push_back(GPSLocation(2, 2));

	ITransport* fakeTransport = FAKE<ITransport>();
	WHEN_CALLED(fakeTransport->GetAllStops()).Return(BY_VAL(testStopsVector));

	realPerson.SetTransport(fakeTransport);

	ASSERT_TRUE(realPerson.TransportStopsAt(testLocation));
}
