#ifdef __linux__

#include "stdafx.h"

#else

#include <string>
#include <exception>
#include <Isolator.h>
#include <gtest/gtest.h>
using namespace std;

#endif

#include "../ClassesUnderTest/Person.h"

class ThrowException : public ::testing::Test
{
public:
	
	virtual void TearDown() 
	{
		ISOLATOR_CLEANUP();
	}
};

/*****************************************
		Simulating exceptions
******************************************/

TEST_F(ThrowException, FakeStdException)
{
	Person person;
	Address* fakeAddress = FAKE<Address>();
#ifdef __linux__
        exception problem;
#else
	exception problem("Something has definitely gone wrong!");
#endif
	WHEN_CALLED(fakeAddress->GetCountry()).Throw(&problem);

	string error("Error");

	string result = person.GetAddressCountry(fakeAddress);

	ASSERT_TRUE(result == error);
	
}

